
PROCEDURE BABTSP(
       N,INF  :INTEGER;
   VAR W      :ARRNN;
   VAR ROUTE  :ARRN;
   VAR TWEIGHT:INTEGER);

   VAR BACKPTR,BEST,COL,FWDPTR,ROW:ARRN;
       I,INDEX                    :INTEGER;

   PROCEDURE EXPLORE(EDGES,COST:INTEGER;VAR ROW,COL:ARRN);
      VAR AVOID,C,COLROWVAL,FIRST,I,J,
          LAST,LOWERBOUND,MOST,R,SIZE :INTEGER;
          COLRED,NEWCOL,NEWROW,ROWRED :ARRN;

      FUNCTION MIN(I,J:INTEGER):INTEGER;
      BEGIN
         IF I <= J THEN MIN:=I ELSE MIN :=J
      END;  { MIN }

      FUNCTION REDUCE(VAR ROW,COL,ROWRED,COLRED:ARRN):INTEGER;
         VAR I,J,RVALUE,TEMP:INTEGER;
      BEGIN
         RVALUE:=0;
         FOR I:=1 TO SIZE DO BEGIN                    { REDUCE ROWS }
            TEMP:=INF;
            FOR J:=1 TO SIZE DO TEMP:=MIN(TEMP,W[ROW[I],COL[J]]);
            IF TEMP > 0 THEN BEGIN
               FOR J:=1 TO SIZE DO
                  IF W[ROW[I],COL[J]] < INF THEN
                     W[ROW[I],COL[J]]:=W[ROW[I],COL[J]]-TEMP;
               RVALUE:=RVALUE+TEMP
            END;
            ROWRED[I]:=TEMP
         END;  { FOR I }
         FOR J:=1 TO SIZE DO BEGIN                 { REDUCE COLUMNS }
            TEMP:=INF;
            FOR I:=1 TO SIZE DO TEMP:=MIN(TEMP,W[ROW[I],COL[J]]);
            IF TEMP > 0 THEN BEGIN
               FOR I:=1 TO SIZE DO
                  IF W[ROW[I],COL[J]] < INF THEN
                     W[ROW[I],COL[J]]:=W[ROW[I],COL[J]]-TEMP;
               RVALUE:=RVALUE+TEMP
            END;
            COLRED[J]:=TEMP
         END;  { FOR J }
         REDUCE:=RVALUE
      END;  { REDUCE }

      PROCEDURE BESTEDGE(VAR R,C,MOST:INTEGER);
         VAR I,J,K,MINCOLELT,MINROWELT,ZEROES:INTEGER;
      BEGIN
         MOST:=-INF;
         FOR I:=1 TO SIZE DO
            FOR J:=1 TO SIZE DO
               IF W[ROW[I],COL[J]] = 0 THEN BEGIN
                  MINROWELT:=INF;  ZEROES:=0;
                  FOR K:=1 TO SIZE DO
                     IF W[ROW[I],COL[K]] = 0 THEN ZEROES:=ZEROES+1
                     ELSE MINROWELT:=MIN(MINROWELT,W[ROW[I],COL[K]]);
                  IF ZEROES > 1 THEN MINROWELT:=0;
                  MINCOLELT:=INF;  ZEROES:=0;
                  FOR K:=1 TO SIZE DO
                     IF W[ROW[K],COL[J]] = 0 THEN ZEROES:=ZEROES+1
                     ELSE MINCOLELT:=MIN(MINCOLELT,W[ROW[K],COL[J]]);
                  IF ZEROES > 1 THEN MINCOLELT:=0;
                  IF (MINROWELT+MINCOLELT) > MOST THEN BEGIN
                                     { A BETTER EDGE HAS BEEN FOUND }
                     MOST:=MINROWELT+MINCOLELT;
                     R:=I;  C:=J
                  END
               END  { IF W[ROW[I],COL[J]] = 0, FOR J, I }
      END;  { BESTEDGE }

   BEGIN                                          { BODY OF EXPLORE }
      SIZE:=N-EDGES;
      COST:=COST+REDUCE(ROW,COL,ROWRED,COLRED);
      IF COST < TWEIGHT THEN
         IF EDGES = (N-2) THEN BEGIN    { LAST TWO EDGES ARE FORCED }
            FOR I:=1 TO N DO BEST[I]:=FWDPTR[I];
            IF W[ROW[1],COL[1]] = INF THEN AVOID:=1
            ELSE AVOID:=2;
            BEST[ROW[1]]:=COL[3-AVOID];  BEST[ROW[2]]:=COL[AVOID];
            TWEIGHT:=COST
         END  { IF EDGES = (N-2) }
         ELSE BEGIN
            BESTEDGE(R,C,MOST);
            LOWERBOUND:=COST+MOST;
            FWDPTR[ROW[R]]:=COL[C];  BACKPTR[COL[C]]:=ROW[R];
            LAST:=COL[C];                          { PREVENT CYCLES }
            WHILE FWDPTR[LAST] <> 0 DO LAST:=FWDPTR[LAST];
            FIRST:=ROW[R];
            WHILE BACKPTR[FIRST] <> 0 DO FIRST:=BACKPTR[FIRST];
            COLROWVAL:=W[LAST,FIRST];  W[LAST,FIRST]:=INF;
            FOR I:=1 TO R-1 DO NEWROW[I]:=ROW[I];      { REMOVE ROW }
            FOR I:=R TO SIZE-1 DO NEWROW[I]:=ROW[I+1];
            FOR I:=1 TO C-1 DO NEWCOL[I]:=COL[I];      { REMOVE COL }
            FOR I:=C TO SIZE-1 DO NEWCOL[I]:=COL[I+1];
            EXPLORE(EDGES+1,COST,NEWROW,NEWCOL);
            W[LAST,FIRST]:=COLROWVAL;     { RESTORE PREVIOUS VALUES }
            BACKPTR[COL[C]]:=0;  FWDPTR[ROW[R]]:=0;
            IF LOWERBOUND < TWEIGHT THEN  BEGIN
               W[ROW[R],COL[C]]:=INF;
               EXPLORE(EDGES,COST,ROW,COL);
               W[ROW[R],COL[C]]:=0
            END
         END;  { ELSE: EDGES < N-2 }
      FOR I:=1 TO SIZE DO                         { UNREDUCE MATRIX }
         FOR J:=1 TO SIZE DO
            W[ROW[I],COL[J]]:=W[ROW[I],COL[J]]+ROWRED[I]+COLRED[J]
   END;  { EXPLORE }

BEGIN                                                   { MAIN BODY }
   FOR I:=1 TO N DO BEGIN
      ROW[I]:=I;  COL[I]:=I;
      FWDPTR[I]:=0;  BACKPTR[I]:=0
   END;
   TWEIGHT:=INF;
   EXPLORE(0,0,ROW,COL);
   INDEX:=1;
   FOR I:=1 TO N DO BEGIN
      ROUTE[I]:=INDEX;  INDEX:=BEST[INDEX]
   END
END;  { BABTSP }

