

PROCEDURE KNAPAPPROX(
       N       :INTEGER;
   VAR P,W,X   :ARRN;
   VAR V,PROFIT:INTEGER;
   VAR EPS     :REAL);

   VAR I,J,K,L,MAXP1,MAXP2,MAXP3,PP,Q,R,S,U,VV:INTEGER;

   PROCEDURE LB(VAR G,H,Q,U:INTEGER);
      { LB FINDS PROFIT Q AND RESIDUAL WEIGHT OF GREEDY TYPE
        SOLUTION WHICH IS ASSUMED TO CONTAIN OBJECTS G AND H }
      VAR K:INTEGER;
   BEGIN
      K:=0;
      REPEAT
         K:=K+1;
         IF (K <> G) AND (K <> H) AND (W[K] <= U) THEN BEGIN
            Q:=Q+P[K];  U:=U-W[K]
         END
      UNTIL K=N
   END;  { LOWER BOUND }

   PROCEDURE MAX;
      { MAX UPDATES MAXP1, MAXP2, AND MAXP3: LARGEST, SECOND
        AND THIRD LARGEST ELEMENTS OF THE PROFIT VECTOR }
   BEGIN
      IF P[I] > MAXP1 THEN BEGIN
         MAXP3:=MAXP2;  MAXP2:=MAXP1;  MAXP1:=P[I]
      END
      ELSE
         IF P[I] > MAXP2 THEN BEGIN MAXP3:=MAXP2;  MAXP2:=P[I] END
         ELSE IF P[I] > MAXP3 THEN MAXP3:=P[I]
   END;  { MAX }

BEGIN                                                   { MAIN BODY }
   I:=1;  U:=V;  PROFIT:=0;
   MAXP1:=0;  MAXP2:=0;  MAXP3:=0;
   WHILE W[I] <= U DO BEGIN               { FINDING GREEDY SOLUTION }
      U:=U-W[I];  MAX;  X[I]:=1;
      PROFIT:=PROFIT+P[I];
      I:=I+1
   END;
   I:=I-1;  S:=I;
   REPEAT
      I:=I+1;
      IF W[I] <= U THEN BEGIN
         U:=U-W[I];  X[I]:=1;  PROFIT:=PROFIT+P[I]
      END
      ELSE X[I]:=0;
      MAX
   UNTIL I=N;
   Q:=PROFIT;
                                    { ONE ELEMENT SUBSETS OF OBJECT }
   K:=0;  L:=0;                { K AND L IDENTIFY THE OBJECTS WHICH }
   FOR I:=S TO N DO               { ARE ASSUMED TO BE IN A SOLUTION }
      IF X[I] <> 1 THEN BEGIN
         VV:=V-W[I];  PP:=P[I];
         LB(I,I,PP,VV);
         IF PP > PROFIT THEN BEGIN PROFIT:=PP;  K:=I END
      END;  {IF X[I] <> 1, FOR I }
   R:=S;                           { TWO ELEMENT SUBSETS OF OBJECTS }
   FOR I:=1 TO N-1 DO BEGIN
      IF I > S THEN R:=I;
      FOR J:=R+1 TO N DO BEGIN
         VV:=V-W[I]-W[J];
         IF VV >= 0 THEN BEGIN
            PP:=P[I]+P[J];
            LB(I,J,PP,VV);
            IF PP > PROFIT THEN BEGIN PROFIT:=PP;  K:=I;  L:=J END
         END
      END  { FOR J }
   END;  { FOR I }
   IF PROFIT > Q THEN BEGIN
      IF K > 0 THEN BEGIN V:=V-W[K];  X[K]:=1  END;
      IF L > 0 THEN BEGIN V:=V-W[L];  X[L]:=1  END;
      FOR I:=1 TO N DO
         IF (I <> K) AND (I <> L) THEN
            IF W[I] <= V THEN BEGIN X[I]:=1;  V:=V-W[I] END
            ELSE X[I]:=0
   END;  { IF PROFIT > Q }
   EPS:=MAXP3/PROFIT;
   IF EPS > 0.33333 THEN EPS:=0.33333
END;  { KNAPAPPROX }


